variables:
  REGISTRY_BASE_URL: registry.gitlab.com/beerlab/iprofi2023/problem/bachelor_problem_2023/base
  REGISTRY_URL: registry.gitlab.com/beerlab/iprofi2023/problem/bachelor_problem_2023/scene

  IMAGE_TAG_NONGPU: $REGISTRY_URL:ubuntu
  IMAGE_TAG_GPU: $REGISTRY_URL:nvidia

  BASE_IMAGE_TAG_NONGPU: $REGISTRY_BASE_URL:ubuntu-latest
  BASE_IMAGE_TAG_GPU: $REGISTRY_BASE_URL:nvidia-latest
  # Tell 'docker:dind' to enable TLS (recommended)
  # and generate certificates in the specified directory.
  DOCKER_TLS_CERTDIR: "/certs"

stages:
  - Build and Publishing

build-push-checker-docker-image-nongpu:
  stage: Build and Publishing
  image: docker:latest
  # Specify an additional image 'docker:dind' ("Docker-in-Docker") that
  # will start up the Docker daemon when it is brought up by a runner.
  services:
    - docker:dind
  before_script:
     - docker pull $IMAGE_TAG_NONGPU-latest
  script:
    - apk update && apk add git
    - docker login -u $REGISTRY_TOKEN_NAME -p $REGISTRY_TOKEN $CI_REGISTRY
    - docker build --cache-from $IMAGE_TAG_NONGPU-latest -t $IMAGE_TAG_NONGPU-latest -t $IMAGE_TAG_NONGPU-$CI_COMMIT_TAG . --build-arg  BASE_IMG=$BASE_IMAGE_TAG_NONGPU
    - docker push $IMAGE_TAG_NONGPU-latest
    - docker push $IMAGE_TAG_NONGPU-$CI_COMMIT_TAG
  only:
    refs:
      - tags

build-push-checker-docker-image-gpu:
  stage: Build and Publishing
  image: docker:latest
  # Specify an additional image 'docker:dind' ("Docker-in-Docker") that
  # will start up the Docker daemon when it is brought up by a runner.
  services:
    - docker:dind
  script:
    - apk update && apk add git
    - docker login -u $REGISTRY_TOKEN_NAME -p $REGISTRY_TOKEN $CI_REGISTRY
    - docker build --pull -t $IMAGE_TAG_GPU-latest -t $IMAGE_TAG_GPU-$CI_COMMIT_TAG . --build-arg  BASE_IMG=$BASE_IMAGE_TAG_GPU
    - docker push $IMAGE_TAG_GPU-latest
    - docker push $IMAGE_TAG_GPU-$CI_COMMIT_TAG
  only:
    refs:
      - tags
